VERSION 5.00
Object = "{7CAC59E5-B703-4CCF-B326-8B956D962F27}#12.0#0"; "COCAFF~1.OCX"
Begin VB.Form frmMain 
   Caption         =   "Test report database"
   ClientHeight    =   8520
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   12735
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   ScaleHeight     =   8520
   ScaleWidth      =   12735
   StartUpPosition =   2  'CenterScreen
   Begin XtremeReportControl.ReportControl wndReportControl 
      Height          =   8535
      Left            =   3600
      TabIndex        =   0
      Top             =   0
      Width           =   4215
      _Version        =   786432
      _ExtentX        =   7435
      _ExtentY        =   15055
      _StockProps     =   64
      BorderStyle     =   3
      ShowGroupBox    =   -1  'True
   End
   Begin VB.PictureBox Picture1 
      BackColor       =   &H80000005&
      Height          =   8505
      Left            =   0
      ScaleHeight     =   8445
      ScaleWidth      =   3315
      TabIndex        =   1
      Top             =   0
      Width           =   3375
      Begin VB.CommandButton cmdGo 
         Caption         =   "Load from database (DAO)"
         Height          =   495
         Left            =   120
         TabIndex        =   4
         Top             =   120
         Width           =   3135
      End
      Begin VB.Frame Frame2 
         BackColor       =   &H80000005&
         Caption         =   "Properties"
         Height          =   7455
         Left            =   120
         TabIndex        =   2
         Top             =   840
         Width           =   3135
         Begin VB.TextBox txtProperties 
            Height          =   285
            Index           =   0
            Left            =   360
            TabIndex        =   3
            Top             =   480
            Visible         =   0   'False
            Width           =   2415
         End
      End
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

'DAO 3.6 reference
Dim mDB        As Database
Dim mRS        As Recordset
Dim qdfTemp    As QueryDef
Dim SQLstring  As String

Dim objTimer As clsTimer

Private Sub cmdGo_Click()

    With wndReportControl
        .Records.DeleteAll
        .Columns.DeleteAll
        .Populate
    End With

    txtProperties(0).Visible = False
    Dim i As Integer
    For i = 1 To txtProperties.Count - 1
        Unload txtProperties(i)
        DoEvents
    Next i
    
    ConnectToTheDatabase App.Path & "\datZipCodes.mdb"
    LoadRecordSet
    
End Sub
Private Sub ConnectToTheDatabase(DatabasePath As String)
    
    Set objTimer = New clsTimer
    objTimer.Calibribrate
    objTimer.Start

    Set mDB = OpenDatabase(DatabasePath, False, False, ";PWD=")
    SQLstring = "SELECT * FROM tblCodPostais"
    Set qdfTemp = mDB.CreateQueryDef("", SQLstring)
    Set mRS = qdfTemp.OpenRecordset
    
    objTimer.Halt
    Me.Caption = objTimer.RunTime

End Sub
Private Sub Form_Load()
    
    With wndReportControl
        .PaintManager.ColumnStyle = xtpColumnOffice2007
        .FullColumnScrolling = True
        .AutoColumnSizing = False
        .SetCustomDraw xtpCustomBeforeDrawRow
    End With

End Sub

Private Sub Form_Resize()
    On Error Resume Next
    Picture1.Move 0, 0, 3455, Me.ScaleHeight
    wndReportControl.Move 3455, 0, Me.ScaleWidth - 3455, Me.ScaleHeight
End Sub

Private Sub Form_Unload(Cancel As Integer)
    
    On Error Resume Next
    If Not mDB Is Nothing Then
        mDB.Close
        Set mDB = Nothing
    End If

End Sub

Private Sub LoadRecordSet()
    
    Set objTimer = New clsTimer
    objTimer.Calibribrate
    objTimer.Start
    
    Dim fld As Field
    Dim XtremeRecord As XtremeReportControl.ReportRecord
    Dim newCol As Integer
    Dim Index As Integer
    Dim i As Integer

    For Each fld In mRS.Fields
        wndReportControl.Columns.Add newCol, fld.Name, 100, True
            txtProperties(0).Visible = True
            newCol = newCol + 1
            Load txtProperties(newCol)
            txtProperties(newCol).Visible = True
            txtProperties(newCol).Move txtProperties(0).Left, txtProperties(0).Top + (newCol * 400)
            txtProperties(newCol).ZOrder 0
    Next fld

    If mRS.RecordCount > 0 Then
        Do While Not mRS.EOF
            Set XtremeRecord = wndReportControl.Records.Add()
            For Index = 0 To mRS.Fields.Count - 1
                With XtremeRecord.AddItem(mRS.Collect(Index))
                    If IsNull(.Value) Then
                        .Value = Empty
                    End If
                End With
            Next
        
            mRS.MoveNext
        Loop
    Else
        MsgBox "Sorry, there are no records in the database.", vbInformation
    End If

    With wndReportControl
        .Populate
        .Navigator.MoveLastRow 'to have the focuschanging event
        .Navigator.MoveFirstRow 'to have the focuschanging event
    End With
    
    objTimer.Halt
    Me.Caption = Me.Caption & " - " & "Loading records time: " & objTimer.RunTime & " - Number of records :" & mRS.RecordCount
    
    mRS.Close
    Set mRS = Nothing

End Sub

Private Sub wndReportControl_FocusChanging(ByVal NewRow As XtremeReportControl.IReportRow, ByVal NewColumn As XtremeReportControl.IReportColumn, ByVal NewItem As XtremeReportControl.IReportRecordItem, Cancel As Boolean)
    Dim selRecord As ReportRecordItem
    If Not NewRow.GroupRow Then
        For Each selRecord In NewRow.Record
            txtProperties(selRecord.Index).Text = selRecord.Caption
        Next selRecord
    End If
End Sub

'
'##############################################################################
'

Private Sub wndReportControl_BeforeDrawRow(ByVal Row As XtremeReportControl.IReportRow, ByVal Item As XtremeReportControl.IReportRecordItem, ByVal Metrics As XtremeReportControl.IReportRecordItemMetrics)

    Dim rptRow As XtremeReportControl.ReportRow
    Dim rptGroupRow As XtremeReportControl.ReportGroupRow
    

    Dim tmp As String
    Dim iLevel As Integer
    Dim i As Integer
    Dim ColIdx As Integer

    If Row.GroupRow Then
        Set rptGroupRow = Row
        With rptGroupRow

            '-- find level of group
            iLevel = 1
            Set rptRow = .ParentRow
            Do Until rptRow Is Nothing
                Set rptRow = rptRow.ParentRow
                iLevel = iLevel + 1
            Loop

            '-- determine index of the grouped column
            ColIdx = wndReportControl.GroupsOrder(iLevel - 1).Index
    
            '-- replace grouprow caption
            tmp = .GroupCaption & " (Level " & iLevel & ", grouped by '" & _
                  wndReportControl.Columns(ColIdx).Caption & "', " & _
                  .Childs.Count & " record(s))"
            Metrics.Text = tmp

        End With
    Else
    End If

End Sub 'wndReportControl_BeforeDrawRow(...)

